﻿package com.manpower
{
    
    import com.cats.view.fx.ShatterMaker;
    import com.greensock.TweenLite;
    import com.greensock.easing.Linear;
    import com.greensock.easing.Strong;
    import com.greensock.plugins.ColorTransformPlugin;
    import com.greensock.plugins.GlowFilterPlugin;
    import com.greensock.plugins.TintPlugin;
    import com.greensock.plugins.TweenPlugin;
    import flash.display.Bitmap;
    import flash.display.MovieClip;
    import flash.display.Sprite;
    import flash.display.StageAlign;
    import flash.display.StageScaleMode;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.text.AntiAliasType;
    import flash.text.TextField;
    import flash.utils.getDefinitionByName;
    
    public class Manpower_Shatter_base extends Sprite
    {
        public var bg:MovieClip;
        
        public var copy13:MovieClip;
        
        public var copy4:MovieClip;
        
        public var copy5:MovieClip;
        
        public var cracks:MovieClip;
        
        public var cta:MovieClip;
        
        public var hero:MovieClip;
        
        public var logo:MovieClip;
        
        public var shatterPiecesContainer:Sprite;
        
        public var smallCracks:MovieClip;
        
        public var textReference:MovieClip;
        
        protected var _clickArea:ClickArea;
        
        protected var _shatterMaker:ShatterMaker;
        
        protected var _shatterPieces:Array = [];
        
        private var _bulgeTarget:Bitmap;
        
        public function Manpower_Shatter_base()
        {
            
            TweenPlugin.activate([ TintPlugin, ColorTransformPlugin, GlowFilterPlugin ]);
            
            if (stage)
            {
                init_stage();
            }
            else
            {
                addEventListener(Event.ADDED_TO_STAGE, event_ADDED_TO_STAGE);
            }
        
        }
        
        protected function f1_end():void
        {
            
            TweenLite.delayedCall(.7, f2_start);
        
        }
        
        protected function f1_start():void
        {
            
            copy13.visible = false;
            
            copy13.copy1.visible = true;
            copy13.copy2.visible = false;
            copy13.copy3.visible = false;
            //copy13.copy4.visible = false;
            copy13.copy5.visible = false;
            
            TweenLite.from(copy13.copy1, .5, { alpha: 0 });
            
            bg.visible = true;
            TweenLite.from(bg, .5, { alpha: 0 });
            
            logo.visible = true;
            TweenLite.from(logo, .5, { alpha: 0 });
            
            copy13.visible = true;
            copy13.cacheAsBitmap = true;
            TweenLite.from(copy13, .5, { alpha: 0 });
            
            TweenLite.delayedCall(.5, f1_end);
        
        }
        
        protected function f2_end():void
        {
            
            TweenLite.delayedCall(.7, f3_start);
        
        }
        
        protected function f2_start():void
        {
            
            TweenLite.to(copy13.copy1, .3, { alpha: 0 });
            
            copy13.copy2.visible = true;
            TweenLite.from(copy13.copy2, .5, { alpha: 0 });
            
            copy13.copy3.visible = false;
            
            TweenLite.delayedCall(.5, f2_end);
        
        }
        
        protected function f3_end():void
        {
            
            TweenLite.delayedCall(.7, f3b_start);
        
        }
        
        protected function f3_start():void
        {
            
            copy13.alpha = .8
            copy13.copy1.visible = false;
            TweenLite.to(copy13.copy2, .3, { alpha: 0 });
            
            copy13.copy3.visible = true;
            TweenLite.from(copy13.copy3, .5, { alpha: 0 });
            
            TweenLite.delayedCall(.5, f3_end);
        
        }
        
        /*
           protected function f3a_end():void
           {
        
           TweenLite.delayedCall(.7, f3b_start);
        
           }
        
           protected function f3a_start():void
           {
        
           copy13.alpha = .8
           copy13.copy2.visible = false;
           TweenLite.to(copy13.copy3, .3, { alpha: 0 });
        
           copy13.copy4.visible = true;
           TweenLite.from(copy13.copy4, .5, { alpha: 0 });
        
           TweenLite.delayedCall(.5, f3a_end);
        
           }
         */
        protected function f3b_end():void
        {
            
            TweenLite.delayedCall(.7, f4_start);
        
        }
        
        protected function f3b_start():void
        {
            
            copy13.alpha = .8
            copy13.copy2.visible = false;
            TweenLite.to(copy13.copy3, .3, { alpha: 0 });
            
            copy13.copy5.visible = true;
            TweenLite.from(copy13.copy5, .5, { alpha: 0 });
            
            cracks.alpha = 0;
            cracks.visible = true;
            cracks.gotoAndPlay("cracks1");
            
            TweenLite.to(cracks, 2, { alpha: 1 });
            
            TweenLite.delayedCall(2, f3b_end);
        
        }
        
        protected function f4_end():void
        {
            
            TweenLite.delayedCall(0, f5_start);
        
        }
        
        protected function f4_start():void
        {
            
            //copy13.copy1.visible = false;
            //copy13.copy2.visible = false;
            //copy13.copy3.visible = false;
            
            // circle out animation or fall down
            var isCircle:Boolean            = false;
            
            TweenLite.delayedCall(0, function(){cracks.visible = false;});
            TweenLite.delayedCall(.04, function(){copy13.visible = false});
            
            createShutter2();
            
            var circleCenterX:Number        = textReference.width * .5 - 0;
            var circleCenterY:Number        = textReference.height * .5 - 0;
            var crashCircleRadius:Number    = 250;
            var crashCircleIncrement:Number = (2 * Math.PI) / _shatterMaker.getPieces().length;
            
            shatterPiecesContainer.visible = true;
            
            cracks.visible = false;
            
            var newShatter:*;
            
            var pieces:Array                = _shatterMaker.getPieces();
            
            //sorting pieces so they fall down in specific order
            
            if (!isCircle)
            {
                var sliceIndex:Number = Math.floor(pieces.length / 4);
                
                var q1:Array          = pieces.slice(0, sliceIndex);
                var q2:Array          = pieces.slice(sliceIndex, sliceIndex + 4).reverse();
                var q3:Array          = pieces.slice(sliceIndex + 4, sliceIndex + 8).reverse();
                var q4:Array          = pieces.slice(sliceIndex + 8);
                
                pieces = q3.concat(q4).concat(q2).concat(q1);
            }
            
            for (var i:uint = 0; i < pieces.length; i++)
            {
                newShatter = pieces[i];
                
                var cd:Sprite     = new Sprite();
                cd.graphics.beginFill(0xff0000, 1);
                
                var cX:Number;
                var cY:Number;
                
                if (!isCircle)
                {
                    
                    cX = 30 + newShatter.x + (Math.random() - .5) * 200;
                    cY = textReference.height * 2;
                }
                else
                {
                    cX = (circleCenterX + Math.cos(i * crashCircleIncrement - (Math.PI * .75)) * crashCircleRadius) + (Math.random() - .5) * 100;
                    cY = circleCenterY + Math.sin(i * crashCircleIncrement - (Math.PI * .75)) * crashCircleRadius + (Math.random() - .5) * 100;
                    
                }
                
                cd.x = cX;
                cd.y = cY;
                
                var scale1:Number = .2 + (Math.random() * 30 / 100);
                var scale2:Number = (Math.random() - .5) * 100;
                
                newShatter.visible = true;
                
                if (!isCircle)
                {
                    
                    TweenLite.to(newShatter, 2, { delay: (i * .04) + ((Math.random() * 10 / 100)), rotation: scale2, ease: Strong.easeOut, alpha: .3, scaleX: scale1, scaleY: scale1, x: cX, y: cY });
                }
                else
                {
                    TweenLite.to(newShatter, 2, { delay: .04 + ((Math.random() * 30 / 100)), rotation: scale2, ease: Strong.easeOut, alpha: .3, scaleX: scale1, scaleY: scale1, x: cX, y: cY });
                    
                }
                
                shatterPiecesContainer.addChild(cd);
                
            }
            
            if (!isCircle)
            {
                TweenLite.delayedCall(1.1, f4_end);
            }
            else
            {
                TweenLite.delayedCall(1, f4_end);
            }
        
        }
        
        protected function f5_end():void
        {
            
            _clickArea.addEventListener(MouseEvent.ROLL_OVER, event_ROLL_OVER);
            _clickArea.addEventListener(MouseEvent.ROLL_OUT, event_ROLL_OUT);
            _clickArea.stage.addEventListener(Event.MOUSE_LEAVE, event_ROLL_OUT);
        
        }
        
        protected function f5_start():void
        {
            
            shatterPiecesContainer.visible = false;
            
            hero.visible = true;
            TweenLite.from(hero, .6, { x: stage.stageWidth * -1, ease: Linear.easeIn });
            
            smallCracks.visible = true;
            
            TweenLite.delayedCall(.8, smallCracks.gotoAndPlay, [ 1 ]);
            
            copy4.visible = true;
            TweenLite.from(copy4, .7, { delay: .5, x: stage.stageWidth * -1 });
            
            copy5.visible = true;
            TweenLite.from(copy5, .7, { delay: .5, x: stage.stageWidth * -1 });
            
            cta.visible = true;
            TweenLite.from(cta, .7, { delay: .5, x: stage.stageWidth * -1 });
            
            TweenLite.delayedCall(1.5, f5_end);
        
        }
        
        protected function init_content():void
        {
            
            bg.visible = false;
            copy13.visible = false;
            
            // trying to smooth out copy animation
            TextField(copy13.copy1.getChildAt(0)).antiAliasType = AntiAliasType.NORMAL;
            TextField(copy13.copy2.getChildAt(0)).antiAliasType = AntiAliasType.NORMAL;
            TextField(copy13.copy3.getChildAt(0)).antiAliasType = AntiAliasType.NORMAL;
            //TextField(copy13.copy4.getChildAt(0)).antiAliasType = AntiAliasType.NORMAL;
            TextField(copy13.copy5.getChildAt(0)).antiAliasType = AntiAliasType.NORMAL;
            /**/
            copy4.visible = false;
            copy5.visible = false;
            cta.visible = false;
            logo.visible = false;
            cracks.visible = false;
            
            textReference.visible = false;
            
            hero.visible = false;
            smallCracks.gotoAndStop(1);
            smallCracks.visible = false;
        
        }
        
        protected function init_stage():void
        {
            
            stage.showDefaultContextMenu = false;
            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;
            
            init_content();
            
            f1_start();
        
        }
        
        private function createShutter2()
        {
            
            // creating shutter pieces based on template clip
            
            shatterPiecesContainer = new Sprite();
            shatterPiecesContainer.x = 0;
            shatterPiecesContainer.y = 0;
            shatterPiecesContainer.visible = false;
            addChild(shatterPiecesContainer);
            
            _shatterMaker = new ShatterMaker();
            
            _shatterMaker.setWidth(stage.stageWidth);
            
            _shatterMaker.setHeight(stage.stageHeight);
            
            _shatterMaker.addLayer(textReference);
            
            _shatterMaker.addLayer(cracks);
            
            var shatterTemplateClass = getDefinitionByName("shatterTemplate") as Class;
            
            _shatterMaker.setTemplate(new shatterTemplateClass());
            
            shatterPiecesContainer.addChild(_shatterMaker.getComposite());
        
        }
        
        private function event_ADDED_TO_STAGE(e:*):void
        {
            
            removeEventListener(Event.ADDED_TO_STAGE, event_ADDED_TO_STAGE);
            init_stage();
        
        }
        
        protected function event_ROLL_OUT(e:*):void
        {
            
            TweenLite.to(cta, .3, { colorTransform: { tint: 0x000000, tintAmount: 0 }});
        
        }
        
        protected function event_ROLL_OVER(e:*):void
        {
            
            TweenLite.to(cta, .3, { colorTransform: { tint: 0x4a6064, tintAmount: 1 }});
            
            TweenLite.to(cta.arrows, .4, { x: 67.5, alpha: 0, onComplete: function(){cta.arrows.alpha = 1;cta.arrows.x = 60.5}});
        
        }
    }
}