package com.manpower
{
    
    import flash.display.Sprite;
    import flash.display.Stage;
    import flash.events.MouseEvent;
    import flash.net.URLRequest;
    import flash.net.navigateToURL;
    
    //import com.walmart.events.CustomEvent;
    public class ClickArea extends Sprite
    {
        
        // Private Properties:
        private var clickthroughURL:String;
        
        //Public Methods:
        public function activateRollover():void
        {
            
            this.addEventListener(MouseEvent.ROLL_OVER, mouseOverHandler);
        
        }
        
        // Initialization:
        public function ClickArea(loaderInfo:Object, stage:Stage, width:Number, height:Number)
        {
            
            var xWidth  = width;
            var yHeight = height;
            
            // Create clickable area
            //this.graphics.beginFill(0xFF0000);
            this.graphics.beginFill(0x00FF00, 0);
            this.graphics.drawRect(10, 10, xWidth, yHeight);
            this.graphics.endFill();
            
            // Determine clickthrough URL (by checking known naming conventions)
            if (loaderInfo.parameters.clicktag != null)
            {
                clickthroughURL = loaderInfo.parameters.clicktag;
            }
            else if (loaderInfo.parameters.clickTag != null)
            {
                clickthroughURL = loaderInfo.parameters.clickTag;
            }
            else if (loaderInfo.parameters.clickTAG != null)
            {
                clickthroughURL = loaderInfo.parameters.clickTAG;
            }
            
            // Add button behaviour
            this.buttonMode = true;
            this.addEventListener(MouseEvent.CLICK, mouseClickHandler);
        
        }
        
        private function mouseClickHandler(e:MouseEvent):void
        {
            
            if (clickthroughURL != null)
            {
                navigateToURL(new URLRequest(clickthroughURL), "_blank");
            }
            else
            {
                trace("Clickthrough");
            }
        
        }
        
        // Protected Methods:
        private function mouseOverHandler(e:MouseEvent):void
        {
        
            //dispatchEvent(new GameEvent(GameEvent.ROLLED_OVER));
        
        }
    }

}